#pragma once

#include "CoreMinimal.h"
#include "Perk.h"
#include "K40P03.generated.h"

class UChargeableComponent;

UCLASS(Blueprintable, Abstract, meta=(BlueprintSpawnableComponent))
class UK40P03 : public UPerk
{
	GENERATED_BODY()

private:
	UPROPERTY(BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UChargeableComponent*> _regressingExitGatesChargeableComponents;

	UPROPERTY(EditAnywhere)
	float _relativeDischargeRate;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _regressionThreshold;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_AdjustExitGateChargeableRegressionRate(UChargeableComponent* chargeableComponent, float percentCompletionChange, float totalPercentComplete);

public:
	UK40P03();
};

FORCEINLINE uint32 GetTypeHash(const UK40P03) { return 0; }
